/*
 * CheckBoxPanel.java
 *
 * Created on 25. jen 2005, 14:07
 */

package gui;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Panel s CheckBoxem, ktery je pouzit ve vizualizaci Shannon-Fanova kodovani.
 * @author Ondrej Hanousek
 */
public class CheckBoxPanel extends javax.swing.JPanel {
    private String text="NO TEXT";
    
    private ChangeEvent changeEvent;
    
    
    /**
     * Metoda pro ovladani listeneru na zmenu checkBoxu.
     * @param l posluchac udalosti, ktery ma byt pridan
     */
    public void addItemStateChangeListener(ChangeListener l){
        listenerList.add(ChangeListener.class, l);
    }
    
    /**
     * Metoda pro ovladani listeneru na zmenu checkBoxu.
     * @param l posluchac udalosti, ktery ma byt odebran
     */
    public void removeItemStateChangeListener(ChangeListener l){
        listenerList.remove(ChangeListener.class,l);
    }
    
    

    
    /**
     * Vutvori panel s checkboxem a definovanym popiskem.
     * @param text Popisek k checkboxu
     */
    public CheckBoxPanel(String text){
       this.text=text;
       initComponents();
    }
    
    /**
     * Vraci stav checkboxu v panelu.
     * @return stav checkboxu
     */
    public boolean isSelected() {
        return checked.isSelected();
    }
    
    private String getText(){
        return text;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        checked = new javax.swing.JCheckBox();

        checked.setText(getText());
        checked.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 0, 0, 0)));
        checked.setMargin(new java.awt.Insets(0, 0, 0, 0));
        checked.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                checkedItemStateChanged(evt);
            }
        });

        add(checked);

    }
    // </editor-fold>//GEN-END:initComponents

    private void checkedItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_checkedItemStateChanged
    fireChange();
    }//GEN-LAST:event_checkedItemStateChanged
    
    private void fireChange(){
        Object[] listeners = listenerList.getListenerList();
        for (int i =0; i<listeners.length; i+=2) {
            if (listeners[i]==ChangeListener.class) {
                if (changeEvent == null)
                    changeEvent = new ChangeEvent(this);
                ((ChangeListener)listeners[i+1]).stateChanged(changeEvent);
            }          
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox checked;
    // End of variables declaration//GEN-END:variables
    
}
