/*
 * EntryDialog.java
 *
 * Created on 3. jen 2005, 17:28
 */

package gui;
import java.awt.event.KeyEvent;
import javax.swing.JOptionPane;


/**
 * Trida, ktera reprezentuje dialog pro zadani noveho vstupu.
 * @author Ondrej Hanousek
 */
public class EntryDialog extends javax.swing.JDialog {
    
    private String valid;
    private String value;
    private boolean canceled=true;

    private BasicApplet applet;
    
    /**
     * Vytvori novy dialog pro vstup.
     * @param main nadrizeny formular
     * @param value hodnota vstupu
     * @param valid abeceda - prijimane znaky
     */
    public EntryDialog(BasicApplet main, String value, String valid) {
        this.value=value;
        this.valid=valid;
        this.applet=main;
        initComponents();
       this.setSize(this.getPreferredSize());
        this.setBounds(main.getX()+main.getWidth()/2-this.getWidth()/2, main.getY()+main.getHeight()/2-this.getHeight()/2, this.getWidth(),this.getHeight());
        validLabel.setText(valid);
    }
    
    /**
     * Metoda pro zjisteni, zda byl dialog ukoncen s OK, nebo CANCEL.
     * @return true - dialog ukoncen tlacitkem cancel
     * false - dialog ukoncen tlacitkem OK
     */
    public boolean canceled(){
        return canceled;
    }
    
    /**
     * metoda pro vraceni zadaneo retezce.
     * @return retezec zadany c dialogu
     */
    public String getText(){
        return value;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jlabel = new javax.swing.JLabel();
        validLabel = new javax.swing.JLabel();
        okBtn = new javax.swing.JButton();
        cancelBtn = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        inputText = new javax.swing.JTextField();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.X_AXIS));

        setTitle(Localisation.getString("newEntryTitle"));
        getAccessibleContext().setAccessibleName("");
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setPreferredSize(new java.awt.Dimension(400, 180));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jlabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jlabel.setText(Localisation.getString("validEntry"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(jlabel, gridBagConstraints);

        validLabel.setText("jLabel2");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 2, 2, 2);
        jPanel1.add(validLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jPanel1, gridBagConstraints);

        okBtn.setText(Localisation.getString("okBtn"));
        okBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(okBtn, gridBagConstraints);

        cancelBtn.setText(Localisation.getString("cancelBtn"));
        cancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBtnActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(cancelBtn, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel1.setText(Localisation.getString("enterInput"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(jLabel1, gridBagConstraints);

        inputText.setText(value);
        inputText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                enterEsc(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                inputTextKeyTyped(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(inputText, gridBagConstraints);

        getContentPane().add(jPanel2);

    }
    // </editor-fold>//GEN-END:initComponents
    
    private void enterEsc(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_enterEsc
        if (evt.getKeyCode()==KeyEvent.VK_ENTER) ok();
        if (evt.getKeyCode()==KeyEvent.VK_ESCAPE) cancel();
    }//GEN-LAST:event_enterEsc
    
    private void inputTextKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_inputTextKeyTyped
        char[] pom=new char[1];
        pom[0]=evt.getKeyChar();
        if (valid.contains(new String(pom))) return;
        evt.consume();
    }//GEN-LAST:event_inputTextKeyTyped
    
    private void cancelBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnActionPerformed
        cancel();
    }//GEN-LAST:event_cancelBtnActionPerformed
    
    private void okBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBtnActionPerformed
        ok();
    }//GEN-LAST:event_okBtnActionPerformed
    
    private void cancel(){
        value="";
        setVisible(false);
    }
    private void ok(){
        if (applet.isValidInput(inputText.getText())){
            canceled=false;
            value=inputText.getText();
            setVisible(false);
        } else {
            JOptionPane.showMessageDialog(this, applet.getInvalidInputMsg(),Localisation.getString("entError"),JOptionPane.ERROR_MESSAGE);
        }
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelBtn;
    private javax.swing.JTextField inputText;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JLabel jlabel;
    private javax.swing.JButton okBtn;
    private javax.swing.JLabel validLabel;
    // End of variables declaration//GEN-END:variables
    
}
