/*
 * Lz77Panel.java
 *
 * Created on 10. prosinec 2005, 11:13
 */

package gui;
import javax.swing.SpinnerNumberModel;

/**
 * Doplnkovy panel pro nastaveni velikost zakodovane casti a 
 * vyhledu pri kodovani LZ 77.
 * @author Ondrej Hanousek
 */
public class Lz77Panel extends javax.swing.JPanel {
    
    /**
     * vytvori panel pro ovladani parametru LZ 77.
     */
    public Lz77Panel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        coded = new javax.swing.JSpinner();
        view = new javax.swing.JSpinner();

        setLayout(new java.awt.GridBagLayout());

        setMinimumSize(new java.awt.Dimension(234, 25));
        setPreferredSize(new java.awt.Dimension(234, 25));
        jLabel1.setText(Localisation.getString("77CodedSize"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jLabel1, gridBagConstraints);

        jLabel2.setText(Localisation.getString("77ViewSize"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        add(jLabel2, gridBagConstraints);

        coded.setFont(new java.awt.Font("Dialog", 0, 12));
        coded.setModel(new SpinnerNumberModel(6,1,10,1));
        coded.setMinimumSize(new java.awt.Dimension(40, 18));
        coded.setPreferredSize(new java.awt.Dimension(40, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        add(coded, gridBagConstraints);

        view.setFont(new java.awt.Font("Dialog", 0, 12));
        view.setModel(new SpinnerNumberModel(4,1,10,1));
        view.setMinimumSize(new java.awt.Dimension(40, 18));
        view.setPreferredSize(new java.awt.Dimension(40, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        add(view, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JSpinner coded;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JSpinner view;
    // End of variables declaration//GEN-END:variables
 
    /**
     * Parametr kodovani LZ 77 - velikost zakodovane casti.
     * @return zvolenou velikost zakodovane casti
     */
    public int getCodedSize(){
        return ((Integer) coded.getValue()).intValue();
    }
    
    /**
     * Parametr kodovani LZ 77 - velikost vyhledu.
     * @return zvolena velikost vyhledu
     */
    public int getViewSize(){
        return ((Integer) view.getValue()).intValue();
    }
    
    /**
     * Vola se pri zakazani panelu kdyz kodovani jiz probiha.
     * @param b povoleni/zakazani panelu
     */
    public void setEnabled(boolean b) {
        
        coded.setEnabled(b);
        jLabel1.setEnabled(b);
        jLabel2.setEnabled(b);
        view.setEnabled(b);
    
    }
}
