/*
 * OutputPanel.java
 *
 * Created on 4. jen 2005, 11:13
 */

package gui;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Rectangle;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultHighlighter;
import gui.utils.BoxHighlightPainter;

/**
 * Panel, ktery vypisuje vystup a zvyraznuje posledni zapsany 
 * retezec.
 * @author Ondrej Hanousek
 */
public class OutputPanel extends javax.swing.JPanel {
       private DefaultHighlighter h=new DefaultHighlighter();
  
       
    /**
     * Vytvori novy panel pro vystup.
     */
    public OutputPanel() {
        initComponents();
          line.setHighlighter(h);
    }
    
    /**
     * Vypise zadany retezec do vystupu a zvyrazni ho.
     * Ostatni zvyrazneni jsou odstranena.
     * @param s retezec ktery ma byt vypsan
     */
    public void write(String s){
         h.removeAllHighlights();
        FontMetrics m=line.getFontMetrics(line.getFont());
        int x=m.charsWidth(line.getText().toCharArray(), 0, line.getText().length());
        int y=0;
        int width=m.charsWidth(s.toCharArray(), 0, s.length());
        int height=m.getHeight();
        line.append(s);
  
        Rectangle v=getVisibleRect();
        Rectangle bounds=new Rectangle(x,y,width, height);
        Rectangle r=new Rectangle(bounds.x-v.width/2,0,v.width,v.height);
        try {
        h.addHighlight(0,1, new BoxHighlightPainter(Color.RED,bounds));
        } catch (BadLocationException ex) {
            System.err.println(ex.getLocalizedMessage());
        }
        innerPanel.scrollRectToVisible(r);
    }
    
    /**
     * Vycisti vystup a zvyrazneni.
     */
    public void reset(){
        line.setText("");
        h.removeAllHighlights();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane();
        innerPanel = new javax.swing.JPanel();
        line = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        innerPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        line.setBackground(innerPanel.getBackground());
        line.setFont(new java.awt.Font("Dialog", 1, 18));
        line.setRows(1);
        innerPanel.add(line);

        jScrollPane1.setViewportView(innerPanel);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jScrollPane1, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel innerPanel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea line;
    // End of variables declaration//GEN-END:variables
    
}
