/*
 * CharInfo.java
 *
 * Created on 1. listopad 2005, 10:09
 *
 */

package gui.parts;

/**
 * Natrida pro vsechny graficke prvky nesouci informaci o znaku.
 * @author Ondrej Hanousek
 */
public abstract class CharInfo extends Part {
    private String character="";
    private int count=1;
    private String code=new String();
    
    /**
     * nastaveni znaku.
     * @param character znak
     */
    public void setCharacter(String character){
        this.character=character;
    }
    
    /**
     * Nastaveni pocitadla.
     * @param count pocet
     */
    public void setCount(int count){
        this.count=count;
    }
    
    /**
     * Zvyseni pocitadla
     */
    public void incrementCounter(){
        count++;
    }
    
    /**
     * Zjisteni znaku
     * @return znak
     */
    public String getCharacter(){
        return character;
    }
    
   /**
    * Zjisteni pozice. Ma ruzne vyuziti v ruznych zdedenych objektech.
    * @return pozice
    */
   public abstract int getPosition();
    
    /**
     * Zjisteni kodu.
     * @return kod
     */
    public String getCode(){
     //   System.out.println(this.code);
        return this.code;
    }
    
    /**
     * Nastaveni kodu
     * @param code kod
     */
    public void setCode(String code){
        this.code=code;
    }
    
    /**
     * Provnani podle znaku.
     * @param o2 Druhy objekt CharInfo
     * @return 0 kdyz stejne, jinak podle abecedy
     */
    public boolean equals(Object o2){
        CharInfo i2=(CharInfo) o2;
        if (character.compareTo(i2.getCharacter())==0) return true;
        return false;
    }
    
    /**
     * Counter
     * @return counter value
     */
    public int getCount(){
        return count;
    }
    
    public String toString(){
        return character+" "+count+" "+getCode();
    }
}
