/*
 * Legend.java
 *
 * Created on 1. listopad 2005, 10:45
 *
 */

package gui.parts;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Rectangle;

/**
 * Objekt, ktery vykresli barevnou legendu - barvu a popisek.
 */
public class Legend extends Part {
    private Color c;
    private String text;
    private final int WIDTH=150;
    private  final int HEIGHT=20;

    /**
     * Vytvori legendu.
     * @param c Barva
     * @param text popisek
     */
    public Legend(Color c, String text) {
        this.c=c;
        this.text=text;
    }
    
    public void paintPart(java.awt.Graphics g1) {
        Graphics2D g=(Graphics2D) g1;
        g.setColor(c);
        g.setStroke(new BasicStroke(2));
        g.drawLine(x+4, y+HEIGHT/2, x+20, y+HEIGHT/2);
        g.setColor(Color.BLACK);
        g.drawChars(text.toCharArray(), 0, text.length(), x+22, y+HEIGHT/2+4);
        //g.draw(getBounds());
    }
    

    /**
     * Minimalni opisujici obdelnik.
     * @return minimalni obdelnik
     */
    public java.awt.Rectangle getBounds() {
        return new Rectangle(x,y,WIDTH,HEIGHT);
    }


    
    
    
    
}
