/*
 * BoxHighlighter.java
 *
 * Created on 13. jen 2005, 0:22
 *
 */

package gui.utils;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;
import javax.swing.text.JTextComponent;
import javax.swing.text.LayeredHighlighter;
import javax.swing.text.View;

/**
    * Podbarvovac pozadi, pouzivany ke zvyrazneni.
    * @author Ondrej Hanousek
    */

   public class BoxHighlightPainter extends LayeredHighlighter.LayerPainter {
        private  Color color; // The color for the background
        private Shape bounds;
        /**
         * Vytvori podbarvovac pozadi s danou barvaou a tvarem.
         * @param bounds ohranicujici tvar
         * @param c barva zvyrazneneho mista
         */
        public  BoxHighlightPainter(Color c, Shape bounds) {
            color = c;
            this.bounds=bounds;
        }
        
        /**
         * This method is never called.
         * @param g .
         * @param offs0 .
         * @param offs1 .
         * @param bounds .
         * @param c .
         */
        public void paint(Graphics g, int offs0, int offs1, Shape bounds,
                JTextComponent c) {
        }
        
        /**
         * Vykresli podbarvovaci tvar.
         * @param g graficky objekt
         * @param offs0 .
         * @param offs1 .
         * @param bounds2 .
         * @param c .
         * @param view .
         * @return .
         */
        public Shape paintLayer(Graphics g, int offs0, int offs1, Shape bounds2,
                JTextComponent c, View view) {
            g.setColor(color);
            Rectangle alloc=bounds.getBounds();
            g.fillRect(alloc.x,alloc.y, alloc.width,alloc.height);
            return alloc;
        }
        
        
    }