/*
 * FibbLength.java
 *
 * Created on 8. leden 2006, 15:20
 *
 */

package gui.utils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

/**
 * Trida pro praci s Fibbonaciho kodem.
 * @author Ondrej Hanousek
 */
public class FibbCode {
    private ArrayList<Integer> d=new ArrayList<Integer>();
    private int max=2;
    
    /**
     * Vytvori tridu, ktera umi vytvorit fibonacciho kod.
     * @param max Inicializacni maximum
     */
    public FibbCode(int max) {
        d.add(1);
        d.add(1);
        this.max=2;
        computeD(max);
        
    }
    
    /**
     * Delka Fibonacciho kodu pro zadane cislo.
     * @param number cislo
     * @return delka Fibonacciho kodu
     */
    public int fibbLength(int number){
        number+=1;
        
        while (number>d.get(max-1)) computeD(max+2);
        
        for (int i=max-1;i>=0;i--) {
            if (number>=d.get(i)) {
                return i+1;
            }
        }
        return 0;
    }
    
    /**
     * Metoda pro ziskani Fibonacciho kodu
     * @param number cislo
     * @return Fibonacciho kod pro zadane cislo
     */
    public String fibbCode(int number) {
        StringBuffer out=new StringBuffer();
        number+=1;
        while (number>d.get(max-1)) computeD(max+2);
        
        for (int i=max-1;i>=1;i--) {
            int val=d.get(i);
            if (number>=val) {
                out.append('1');
                number-=val;
            } else {
                out.append('0');
            }
        }     
        return out.reverse().substring(0,out.lastIndexOf("1")+1)+"1";
    }
      
    
    private void computeD(int newMax) {
        for (int i=max;i<newMax;i++) {
            d.add(d.get(i-1)+d.get(i-2));
        }
        max=newMax;
        
        
        
    }
    
    
}
