/*
 * PngFilenameFilter.java
 *
 * Created on 9. jen 2005, 13:02
 *
 */

package gui.utils;
import gui.Localisation;
import javax.swing.filechooser.FileFilter;



/**
 * Filtr pro soubory .png.
 * @author Ondrej Hanousek
 */
public class PngFileFilter extends FileFilter {
    
    /**
     * Vytvori filtr na souboru .png.
     */
    public PngFileFilter() {
    }
    
    /**
     * Vraci tru pro .png soubory.
     * @param file soubor
     * @return true kdyz soubor konci na .png
     */
    public boolean accept(java.io.File file) {
        if ( file != null ) {
            if (file.isDirectory()) 
            {
                return true;
            }
            else {
            return file.getName().endsWith( ".png" );    
            }
            
        } else {
            return false;
        }
    }
    
    /**
    * Returns the human readable description of this filter.
    * @return popisek filtru
    */
   public String getDescription()
      {
      return Localisation.getString("PNG");
      }
}
