/*
 * FGKInputStream.java
 *
 * Created on 7. listopad 2005, 12:28
 */

package streams;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.TreeSet;
import pradny.BitInputStream;
import pradny.EOSException;
import streams.utils.ByteInfoFGK;
import streams.utils.ByteInfoFGKOrderComparator;

/**
 * Trida - stream, ktera realizuje 
 * adaptivni Huffmanovo dekodovani.
 * @author Ondrej Hanousek
 */
public class FGKInputStream extends FilterInputStream {
    private ByteInfoFGK root, actual;
    private BitInputStream in;
    private TreeSet<ByteInfoFGK> allNodes=new TreeSet<ByteInfoFGK>(new ByteInfoFGKOrderComparator());
    
    
    /**
     * Zalozi novou dekodovaci tridu nad danym streamem.
     * @param is podrizeny stream
     */
    public FGKInputStream(InputStream is) {
        super(is);
        root=new ByteInfoFGK();
        actual=root;
        in=new BitInputStream(is);
        allNodes.add(actual);
    }
    
    /**
     * cteni dekodovanych dat
     * @throws java.io.IOException chyba pri cteni nebo dekodovani
     * @return dekodovana data, nebo -1 pri konci
     */
    public int read() throws java.io.IOException {
        int retval;
        actual=root;
        while (!actual.isLeaf()) {
            boolean bit;
            try {
                bit=in.readBit();
             //  System.out.print(bit+" ");
            } catch (EOSException e) {
                return -1;
            }
            if (bit) { actual=actual.getOne(); }
            else { actual=actual.getZero(); }
        }
        if (actual.isZero()) {
            
            try {
                
               retval=boolArrayToByte(in.readBits(8));
              // retval = in.readByte();
           //     retval=retval & 0xff;
        //   System.out.println(retval);
            } catch (EOSException ex) {
           // return -1;
    throw new IOException(ex.getMessage());
            }
            ByteInfoFGK newByte=new ByteInfoFGK(retval);
            ByteInfoFGK newZero=new ByteInfoFGK();
 //           ByteInfoFGK oldParent=actual.getParent();
            int order=actual.getOrder();
            actual.setChildren(newZero, newByte);
            newByte.setOrder(order-1);
            newZero.setOrder(order-2);
            allNodes.add(newByte);
            allNodes.add(newZero);
            actual=newByte;
      //     System.out.println(newByte);
           // retval=retval & 0xff;
           
        } else {
            retval=actual.getData();
            retval=retval & 0xff;
  //     System.out.println(retval);
        }
        FGKOutputStream.updateTree(allNodes,actual);
   //    root.updateChildrenCode();
   // System.out.println(allNodes);
        return retval;
    }
    
    
     private static int boolArrayToByte(boolean[] bits){
        int ret=0;
        int mask=1;
        for (int i=7;i>=0;i--){
            if (bits[i]) {
                ret=ret | mask;
            }
            mask = mask <<1;
            
        }
        return ret;
    }
}
