/*
 * ByteInfoCodeComparator.java
 *
 * Created on 1. jen 2005, 14:35
 *
 */

package streams.utils;

import java.util.Arrays;
import java.util.Comparator;


/**
 * Trida pro porovnani dvou objektu ByteInfo podle kodu.
 * @author Ondrej Hanousek
 */
public class ByteInfoCodeComparator  implements  Comparator<ByteInfo> {
        
    
        /**
         * vola se pri porovnani dvou ByteInfo.
         * @param b1 prvni objekt 
         * @param b2 druhy objekt
         * @return 0 kdyz jso ustejne, jinak podle velikosti kodu 
         */
        public int compare(ByteInfo b1,ByteInfo b2){
            int pom=compar(b1,b2);
           //System.out.println(b1.toString()+"..."+b2.toString()+" =="+pom);
            return pom;
        }
    
      private int compar(ByteInfo b1,ByteInfo b2) {
          
            boolean[] bits1=b1.getCodeBits();
            boolean[] bits2=b2.getCodeBits();
            if (Arrays.equals(bits1,bits2)) return 0;
            int min=Math.min(bits1.length,bits2.length);
            if (min==0) return bits1.length-bits2.length;
            for (int i=0;i<min;i++){
                if (bits1[i]!=bits2[i]){
                    return bits1[i]?1:-1;   
                }
            }
       //     System.out.println(Arrays.toString(bits1) + " " + Arrays.toString(bits2));
                  
            return -1;
        }
    }
    
